| Web Services for Remote Management 14.0 Reference documentation for web service interfaces to support remote management of Symantec Endpoint Protection

- Home
- Packages
- Classes

- Class List
- Class Hierarchy
- Class Members

List of all members | Public Member Functions
com.symantec.sepm.webservice.client.ClientService Interface Reference

The ClientService API provides functionality for getting lists of clients or lists of client groups against which you can run the methods of other web services. More...

Inheritance diagram for com.symantec.sepm.webservice.client.ClientService:

## Public Member Functions
ComputerResult | getComputersByIP (@WebParam(name="ipAddresses") String[] ipAddresses,@WebParam(name="pagingOptions") PagingOptions pagingOptions,@WebParam(name="context") Context context) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Returns a list of computer GUIDs from a provided list of computer IP addresses. More...
ComputerResult | getQuarantinedComputers (@WebParam(name="pagingOptions") PagingOptions pagingOptions,@WebParam(name="context") Context context) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Returns a list of computer GUIDs representing quarantined computers. More...
ComputerResult | getComputersByHostName (@WebParam(name="computerHostNames") String[] computerHostNames,@WebParam(name="pagingOptions") PagingOptions pagingOptions,@WebParam(name="context") Context context) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Returns a list of computer GUIDs from a provided list of computer hostnames. More...
GroupResult | getGroupsByName (@WebParam(name="groupName") String groupName,@WebParam(name="pagingOptions") PagingOptions pagingOptions,@WebParam(name="context") Context context) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Returns a list of group IDs for Symantec Endpoint Protection Manager groups from the specified group name(s) More...
int | acknowledgeRiskEventEntries (@WebParam(name="eventIds") String[] eventIds) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Acknowledges (leaves alone) the specified risks that were found when a PowerEraser command request was issued with type "Scan" or "ScanWithRootkit." The risks to leave alone are specified by using the eventId field of the RiskEventInfo object. More...
RiskEventResult | getRiskEvents (@WebParam(name="commandID") String commandID,@WebParam(name="pagingOptions") PagingOptions pagingOptions,@WebParam(name="context") Context context) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Returns the list of risks that were found when a runClientCommandPowerEraser() command request was issued with a PowerEraserCommand object argument that specified a command type of "Scan" or "ScanWith Rootkit." The commandID parameter is provided by the CommandClientResult object that is returned from the PowerEraser command. More...
PagingOptions | createPagingOptions ()
| Creates a PagingOptions object. More...
Context | createContext ()
| Creates a Context object. More...

## Detailed Description

The ClientService API provides functionality for getting lists of clients or lists of client groups against which you can run the methods of other web services.

Client lists are returned as lists of computer GUIDs. Group lists are returned as lists of group IDs.

Clients can be specified by individual IP address or hostname, by lists of IP addresses or hostnames, or by the name of a Symantec Endpoint Protection Manager group (group name). For more information about groups, see the Symantec Endpoint Protection documentation.

The returned computer GUIDs are intended for use as input parameters to other web methods, especially the methods provided in the CommandService API and in the PolicyService API. Group IDs can be used as input parameters to the methods of the PolicyService API.

This API also includes methods to create a default PagingOptions object and a default Context object. These objects may be useful if you write your web service calls in PowerShell or another scripting language. Developers who use higher-level languages should be able to create these objects directly, or they can use these helper methods.

See also
  PagingOptions
  Context

## Member Function Documentation

ComputerResult com.symantec.sepm.webservice.client.ClientService.getComputersByIP | ( | @WebParam(name="ipAddresses") String[] | ipAddresses,
|  | @WebParam(name="pagingOptions") PagingOptions | pagingOptions,
|  | @WebParam(name="context") Context | context
| ) |  | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Returns a list of computer GUIDs from a provided list of computer IP addresses.

In addition to the computer GUIDs, the returned ComputerResult object provides the following:

- A boolean object to indicate hasMoreResults

- If hasMoreResults = true, then the context value to retrieve the next set of results
  See also
    PagingOptions
    Context
  Parameters

    ipAddresses | list of IP addresses for which to provide computer GUIDs
    pagingOptions | object that provides pagination information for returned result sets. Parameter sortColumn can be "Computername".
    context | (required) object that provides the starting index for multiple sets of results

  Returns
    a ComputerResult object
  Exceptions

    InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
    InvalidArgumentServiceException | if the client supplied invalid parameters
    ServiceException | if the web service encountered an error processing the web request

ComputerResult com.symantec.sepm.webservice.client.ClientService.getQuarantinedComputers | ( | @WebParam(name="pagingOptions") PagingOptions | pagingOptions,
|  | @WebParam(name="context") Context | context
| ) |  | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Returns a list of computer GUIDs representing quarantined computers.

In addition to the computer GUIDs, the returned ComputerResult object provides the following:

- A boolean object to indicate hasMoreResults

- If hasMoreResults = true, then the context value to retrieve the next set of results
  See also
    PagingOptions
    Context
  Parameters

    pagingOptions | object that provides pagination information for returned result sets. Parameter sortColumn can be "Computername".
    context | (required) object that provides the starting index for multiple sets of results

  Returns
    a ComputerResult object
  Exceptions

    InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
    InvalidArgumentServiceException | if the client supplied invalid parameters
    ServiceException | if the web service encountered an error processing the web request

ComputerResult com.symantec.sepm.webservice.client.ClientService.getComputersByHostName | ( | @WebParam(name="computerHostNames") String[] | computerHostNames,
|  | @WebParam(name="pagingOptions") PagingOptions | pagingOptions,
|  | @WebParam(name="context") Context | context
| ) |  | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Returns a list of computer GUIDs from a provided list of computer hostnames.

The specified hostname can include the network domain name.

The computerHostNames parameter can be specified in any of the following formats:

- hostname@domainName. Returns GUIDs for all computers that match both the hostname and the domain name

- hostname. Returns GUIDs for all computers that match the hostname. Multiple GUIDs can be returned if the same hostname exists in multiple domains.

- @domainName. If you specify the domain name, it must be preceded by the "@" symbol. Returns GUIDs for all computers in the specified domain.
  See also
    PagingOptions
    Context
  Parameters

    computerHostNames | list of hostnames for which to provide computer GUIDs
    pagingOptions | object that provides pagination information for returned result sets. Parameter sortColumn can be "Computername".
    context | (required) object that provides the starting index for multiple sets of results

  Returns
    a ComputerResult object.
  See also
    getComputersbyIP
  Exceptions

    InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
    InvalidArgumentServiceException | if the client supplied invalid parameters
    ServiceException | if the web service encountered an error processing the web request

GroupResult com.symantec.sepm.webservice.client.ClientService.getGroupsByName | ( | @WebParam(name="groupName") String | groupName,
|  | @WebParam(name="pagingOptions") PagingOptions | pagingOptions,
|  | @WebParam(name="context") Context | context
| ) |  | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Returns a list of group IDs for Symantec Endpoint Protection Manager groups from the specified group name(s)

In addition to the group IDs, the returned GroupResult object provides the following:

- A boolean object to indicate hasMoreResults

- If hasMoreResults = true, then the context value to retrieve the next set of results

The groupName parameter can be specified in either of the following formats:

- A complete group name path. Specifying the parameter in this format returns information only about the group whose name is specified. No information about child groups is returned. Example: MyCompany Group.

- A pathname that includes a wildcard character. Only the asterisk (*) wildcard character is supported. It can be used only as the last character in the group name. Example: MyCompany*, MyCompany*

- A wildcard character (*) used anywhere except as the last character causes an invalid argument exception.

- A forward slash (/) or a backward slash () is accepted as a path delimiter.
  See also
    PagingOptions
    Context
  Parameters

    groupName | group name or full group path for which to provide the GroupResult
    pagingOptions | object that provides pagination information for returned result sets. Parameter sortColumn can be groupName.
    context | (required) object that provides the starting index for multiple sets of results

  Returns
    GroupResult object
  Exceptions

    InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
    InvalidArgumentServiceException | if the client supplied invalid parameters
    ServiceException | if the web service encountered an error processing the web request

int com.symantec.sepm.webservice.client.ClientService.acknowledgeRiskEventEntries | ( | @WebParam(name="eventIds") String[] | eventIds | ) | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Acknowledges (leaves alone) the specified risks that were found when a PowerEraser command request was issued with type "Scan" or "ScanWithRootkit." The risks to leave alone are specified by using the eventId field of the RiskEventInfo object.

Unlike the other actions associated with the PowerEraser command, a call to this method is not a command as such. No object is returned. The specified eventIds are flagged as acknowledged in the database, and the return integer indicates that the flag was successfully applied.

Note that the InvalidArgumentServiceException can be thrown in the following cases:

- If the eventId provided is not a valid GUID
- If the eventId provided is generated by a user who has higher access right than the user who issued the command.

For example, an InvalidArgumentServiceException is thrown if a limited admin calls this web method and passes and eventID that was generated by a system admin.

Parameters

  eventIds | list of eventIds to acknowledge (leave alone).

See also
  RiskEventInfo

Returns
  integer value that indicates that the specified eventIds were acknowledged (left alone)

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

RiskEventResult com.symantec.sepm.webservice.client.ClientService.getRiskEvents | ( | @WebParam(name="commandID") String | commandID,
|  | @WebParam(name="pagingOptions") PagingOptions | pagingOptions,
|  | @WebParam(name="context") Context | context
| ) |  | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Returns the list of risks that were found when a runClientCommandPowerEraser() command request was issued with a PowerEraserCommand object argument that specified a command type of "Scan" or "ScanWith Rootkit." The commandID parameter is provided by the CommandClientResult object that is returned from the PowerEraser command.

If the pagingOptions parameter is null, this method uses the default values. The following values are the defaults:

- DEFAULT_PAGE_SIZE (= 100 records)

- SortOrder.ASCENDING

- sortColumn.Computername

sortColumn can be one of the following:

- Computername

See also
  PagingOptions

If the context parameter is null, this method uses the default offset value, 1. Otherwise, this method uses the existing offset value from the context. The updated context object is returned to the caller by the RiskEventResult object. To retrieve the next set of results, use this updated context object.

See also
  Context

If there is no information to return in the RiskEventResult object, the fields that the object contains are returned as null values.

Parameters

  commandID | a unique identifier for the command for which the details are to be retrieved
  pagingOptions | object that contains pagination information for returned result sets
  context | (required) object that provides the starting index for multiple sets of results

Returns
  a RiskEventResult object

See also
  RiskEventResult

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

PagingOptions com.symantec.sepm.webservice.client.ClientService.createPagingOptions | ( |  | ) |

Creates a PagingOptions object.

This method is provided as a convenience for developers using PowerShell or other scripting languages. It lets the caller create a default object that can be initialized and passed as an input parameter to other web services. Developers who use higher-level languages should be able to create this object directly, or they can use this helper method.

See also
  PagingOptions

Returns
  a new PagingOptions object with values set to their defaults

Implemented in com.symantec.sepm.webservice.client.ClientServiceImpl.

Context com.symantec.sepm.webservice.client.ClientService.createContext | ( |  | ) |

Creates a Context object.

This method is provided as a convenience for developers using PowerShell or other scripting languages. It lets the caller create a default object that can be initialized and passed as an input parameter to other web services. Developers who use higher-level languages should be able to create this object directly, or they can use this helper method.

See also
  Context

Returns
  a new Context object with values set to their defaults

Implemented in com.symantec.sepm.webservice.client.ClientServiceImpl.